Attribute VB_Name = "GetWriteINIFile"
Option Explicit
Const MODULE_NAME As String = "GetWriteINIFile"
'API-Funktionen deklarieren
Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyName As Any, ByVal lsString As Any, ByVal lplFilename As String) As Long
Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationname As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long

Public Function SaveINISetting(ByVal FileName As String, ByVal Key As String, ByVal Setting As String, ByVal Value As String)
'/* Begin Error Handler
On Error GoTo HandleError
    Call mProcStack.EnterProc("SaveINISetting", MODULE_NAME)

   Call WritePrivateProfileString(Key, Setting, Value, FileName)

'/* End Error Handler
SaveINISetting_Done:
    Call mProcStack.ExitProc("SaveINISetting")
    Exit Function

HandleError:
    Process_Error MODULE_NAME, Err, "SaveINISetting"
    Resume SaveINISetting_Done

End Function

Public Function GetINISetting(ByVal FileName As String, ByVal Key As String, ByVal Setting As String, ByVal Default As Variant) As Variant
'/* Begin Error Handler
On Error GoTo HandleError
    Call mProcStack.EnterProc("GetINISetting", MODULE_NAME)

   Dim TEMP As String * 1024

   Call GetPrivateProfileString(Key, Setting, Default, TEMP, Len(TEMP), FileName)
   GetINISetting = Mid(TEMP, 1, InStr(1, TEMP, Chr(0)) - 1)
   
'/* End Error Handler
GetINISetting_Done:
    Call mProcStack.ExitProc("GetINISetting")
    Exit Function

HandleError:
    Process_Error MODULE_NAME, Err, "GetINISetting"
    Resume GetINISetting_Done

End Function
