Attribute VB_Name = "OpenSave"
Option Explicit

Declare Function SHBrowseForFolder Lib "shell32.dll" Alias _
    "SHBrowseForFolderA" (lpBrowseInfo As BROWSEINFO) As Long
   
Declare Function SHGetPathFromIDList Lib "shell32.dll" Alias _
    "SHGetPathFromIDListA" (ByVal pidl As Long, ByVal pszPath$) As Long
   
Declare Function GetOpenFileName Lib "comdlg32.dll" Alias _
    "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
   
Declare Function GetSaveFileName Lib "comdlg32.dll" Alias _
    "GetSaveFileNameA" (pSavefilename As SAVEFILENAME) As Long
   
Private Type BROWSEINFO
    hOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iTmage As Long
End Type

Private Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type

Private Type SAVEFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As Long
End Type

Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_READONLY = &H1
Public Const OFN_HIDEREADONLY = &H4
Public Const BIF_RETURNONLYFSDIRS = &H1

Public Function VerzeichnisWhlen(Title$, XHwnd As Long) As String

    Dim x As Long, BInfo As BROWSEINFO, dwIList As Long
    Dim szPath$, wPos%

    With BInfo
        .hOwner = XHwnd
        .lpszTitle = Title
        .ulFlags = BIF_RETURNONLYFSDIRS
    End With
    dwIList = SHBrowseForFolder(BInfo)
    szPath = Space$(512)
    x = SHGetPathFromIDList(ByVal dwIList, ByVal szPath)
    If x Then
        wPos = InStr(szPath, Chr(0))
        VerzeichnisWhlen = Left$(szPath, wPos - 1)
      Else
        VerzeichnisWhlen = " "
    End If

End Function

Public Function Dateiffnen(Optional Titel, Optional Filter, _
                            Optional DefExtension, Optional Aktdir) As String

    Dim strDateiName$, strDlgTitel$, strFilter$
    Dim strDefExtension$, strAktDir$, strNull$
    Dim OpenDlg As OPENFILENAME
   
    strNull = Chr$(0)
    strDateiName = String$(512, 0)
    If IsMissing(Titel) Then
        strDlgTitel = "Datei ffnen" & strNull
      Else
        strDlgTitel = Titel & strNull
    End If
    If IsMissing(Filter) Then
        strFilter = "Alle Dateien" & strNull _
            & "*.*" & strNull & strNull
      Else
        strFilter = Filter
    End If
    If IsMissing(DefExtension) Then
        strDefExtension = strNull
      Else
        strDefExtension = DefExtension & strNull
    End If
    If IsMissing(Aktdir) Then
        strAktDir = CurDir$ & strNull
      Else
        strAktDir = Aktdir & strNull
    End If
    With OpenDlg
        .lStructSize = Len(OpenDlg)
        .hwndOwner = Screen.ActiveForm.hwnd
        .lpstrFilter = strFilter
        .nFilterIndex = 1
        .lpstrFile = strDateiName
        .nMaxFile = Len(strDateiName)
        .lpstrInitialDir = strAktDir
        .lpstrTitle = strDlgTitel
        .flags = OFN_FILEMUSTEXIST Or OFN_READONLY
        .lpstrDefExt = strDefExtension
        If GetOpenFileName(OpenDlg) <> 0 Then
            Dateiffnen = Left$(.lpstrFile, _
                InStr(.lpstrFile, strNull) - 1)
          Else
            Dateiffnen = " "
        End If
    End With

End Function

Public Function DateiSpeichern(Optional Titel, Optional Filter, _
                               Optional DefExtension, Optional Aktdir) _
                              As String

    Dim strDateiName$, strDlgTitel$, strFilter$
    Dim strDefExtension$, strAktDir$, strNull$
    Dim SaveDlg As SAVEFILENAME
   
    strNull = Chr$(0)
    strDateiName = String$(512, 0)
    If IsMissing(Titel) Then
        strDlgTitel = "Datei ffnen" & strNull
      Else
        strDlgTitel = Titel & strNull
    End If
    If IsMissing(Filter) Then
        strFilter = "Alle Dateien" & strNull _
            & "*.*" & strNull & strNull
      Else
        strFilter = Filter
    End If
    If IsMissing(DefExtension) Then
        strDefExtension = strNull
      Else
        strDefExtension = DefExtension & strNull
    End If
    If IsMissing(Aktdir) Then
        strAktDir = CurDir$ & strNull
      Else
        strAktDir = Aktdir & strNull
    End If
    With SaveDlg
        .lStructSize = Len(SaveDlg)
        .hwndOwner = Screen.ActiveForm.hwnd
        .lpstrFilter = strFilter
        .nFilterIndex = 1
        .lpstrFile = strDateiName
        .nMaxFile = Len(strDateiName)
        .lpstrInitialDir = strAktDir
        .lpstrTitle = strDlgTitel
        .flags = OFN_HIDEREADONLY
        .lpstrDefExt = strDefExtension
        If GetSaveFileName(SaveDlg) <> 0 Then
            DateiSpeichern = Left$(.lpstrFile, _
                InStr(.lpstrFile, strNull) - 1)
          Else
            DateiSpeichern = " "
        End If
    End With

End Function



